#include <stdio.h>
#include <math.h>
#include <mpi.h>

#define N 1000


void main(int argc, char *argv[])
{
  int rank,p,i,j,k,lnbr,rnbr,n;
  double *x, *y, correl, gcorrel,buf;
  MPI_Status status;
  double temp;

  MPI_Init(&argc, &argv);
  MPI_Comm_rank(MPI_COMM_WORLD, &rank);
  MPI_Comm_size(MPI_COMM_WORLD, &p);

  /* initialize local block */
  n=N/p;
  x = (double*)malloc(sizeof(double) * n );
  y = (double*)malloc(sizeof(double) * n);
  
  for (i=0;i<n;i++){
     x[i] = y[i]= i+rank*n;
  } /* for */
  correl = 0.0;

  lnbr = (rank - 1 + p)%p;
  rnbr = (rank + 1) % p;

  /* compute local correlation */

  for(k=0;k<p;k++){
     for(j=0;j<n;j++)
        for(i=0;i<n;i++)
           correl += fabs(x[i]*x[i] + y[j]*y[j]);
          
     MPI_Send(y,n,MPI_DOUBLE,lnbr,0,MPI_COMM_WORLD);
     MPI_Recv(y,n,MPI_DOUBLE,rnbr,0,MPI_COMM_WORLD,&status);
  } /* for */

  /* global correlation */
  MPI_Reduce(&correl,&gcorrel,1,MPI_DOUBLE,MPI_SUM,0,MPI_COMM_WORLD);

  if (rank == 0){
     printf("The result is: %g\n",gcorrel);
     fflush(stdout);
  } /* if */

  MPI_Finalize();
  exit(0);
} /* main */
